# Learning more from Lagom examples

After getting started with Lagom's Hello World example, you can learn more about Lagom by downloading and
running Lagom's "Shopping Cart" example (either [shopping-cart-scala][] or [shopping-cart-java][]).

[shopping-cart-scala]: https://github.com/lagom/lagom-samples/tree/1.6.x/shopping-cart/shopping-cart-scala
[shopping-cart-java]: https://github.com/lagom/lagom-samples/tree/1.6.x/shopping-cart/shopping-cart-java

Some of the Lagom features you can observe include:

* How to use persistence
* How to use the message broker API
* How to communicate between services

For focused examples, check the [lagom-samples](https://github.com/lagom/lagom-samples) repository on GitHub. Each sample describes how to achieve a particular goal, such as:

* How to use Lagom with [Lightbend Telemetry](https://developer.lightbend.com/docs/telemetry/current/home.html)
* How to use Lagom with Cassandra for write-side persistence and JDBC for a read-side view
* How to use gRPC as the communication mechanism between two Lagom services
* How to deploy a Lagom Maven application in [OpenShift](https://developer.lightbend.com/guides/openshift-deployment/lagom/index.html)?
* How to use Lagom with [Akka Couchbase Persistence](https://doc.akka.io/docs/akka-persistence-couchbase/current/)
